﻿using System;
using System.Collections.Generic;
using System.Web.Http;

namespace CompanyFinanceInfo.Controllers
{
    public class InfoController : ApiController
    {
        private static Dictionary<string, CompanyInfo> _companyDatabase = new Dictionary<string, CompanyInfo>();

        [HttpGet]
        public CompanyInfo Company(string VAT, string apiKey = "")
        {
            if (!string.IsNullOrWhiteSpace(apiKey) && apiKey != "1234")
                return null;

            if (string.IsNullOrWhiteSpace(VAT))
                return null;

            if (_companyDatabase.ContainsKey(VAT))
                return _companyDatabase[VAT];

            return CreateNewCompany(VAT);
        }

        private Random _rand = new Random();
        private CompanyInfo CreateNewCompany(string VAT)
        {
            string[] companyNames = {"Microsoft", "Cronus", "Contoso"};
            string[] addressLines = {"Kanalvej 8", "Ameriška ulica 8", "Microsoft One Way"};
            string[] countries = { "Slovenia", "Denmark", "USA" };

            var ci = new CompanyInfo()
            {
                Name = companyNames[_rand.Next(companyNames.Length)],
                AddressLine = addressLines[_rand.Next(addressLines.Length)],
                Country = countries[_rand.Next(countries.Length)],
                Postcode = Convert.ToString(_rand.Next(99) * 100),
                VAT = VAT
            };

            _companyDatabase.Add(VAT, ci);
            return ci;
        }
    }

    public class CompanyInfo
    {
        public string Name { get; set; }
        public string AddressLine { get; set; }
        public string Postcode { get; set; }
        public string Country { get; set; }
        public string VAT { get; set; }
    }
}