codeunit 70000004 "Company Info service"
{
    trigger OnRun();
    begin
    end;

    procedure GetCompanyInfo(vat: Text; var address : Record "Company Info" temporary);
    var
        endpoint : TextConst ENU = 'http://localhost/api/info/?vat=';
        httpClient : HttpClient;
        httpResponse : HttpResponseMessage;
        companyInfoSetup : Record "Company Info Setup";
        tempBlob : Record TempBlob temporary;
        contentInStream : InStream;
        jsonResponse : JsonToken;
        jsonToken : JsonToken;
    begin
        if not httpClient.Get(endpoint + vat, httpResponse) then
            Error('Failed to contact the address endpoint.');

        if not httpResponse.IsSuccessStatusCode then
            exit;

        tempBlob.Init;
        tempBlob.Blob.CreateInStream(contentInStream);
        httpResponse.Content.ReadAs(contentInStream);
        jsonResponse.ReadFrom(contentInStream);

        jsonResponse.SelectToken('Name', jsonToken);
        address.Name := jsonToken.AsValue.AsText;
        jsonResponse.SelectToken('Country', jsonToken);
        address.Country := jsonToken.AsValue.AsText;
        jsonResponse.SelectToken('VAT', jsonToken);
        address."VAT No." := jsonToken.AsValue.AsText;

        jsonResponse.SelectToken('AddressLine', jsonToken);
        address.Address := CopyStr(jsonToken.AsValue.AsText,MaxStrLen(address.Address));        
    end;
}